<?php

namespace Ulmus\Common\PdoObject;

class SqlitePdoObject extends SqlPdoObject
{
    public bool $inTransaction = false;

    public function inTransaction(): bool
    {
        return $this->openedTransaction > 0;
    }

    public function commit(): bool
    {
        if ( 0 === --$this->openedTransaction) {
            return $this->exec("COMMIT") !== false;
        }

        return false;
    }

    protected function openTransaction(): bool
    {
        return $this->exec("BEGIN IMMEDIATE TRANSACTION") !== false;
    }
}