<?php

namespace Ulmus\SearchRequest\Attribute;

use Ulmus\SearchRequest\SearchMethodEnum;

#[\Attribute(\Attribute::TARGET_PROPERTY)]
class SearchWhere extends SearchParameter
{
    public function __construct(
        public null|string|array $parameter = null,
        public null|string|\Stringable|array $field = null,
        public bool $toggle = false,
        public SearchMethodEnum $method = SearchMethodEnum::Where,
        public string $description = "",
        public PropertyValueSource|array $source = PropertyValueSource::QueryParams,
    ) {}
}